Index: bitlbee.h
===================================================================
--- bitlbee.h	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ bitlbee.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,6 +1,6 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2013 Wilmer van der Gaast and others                *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
   \********************************************************************/
 
@@ -20,6 +20,6 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
@@ -27,24 +27,13 @@
 #define _BITLBEE_H
 
-#ifdef __cplusplus
-extern "C" {
-#endif
-
-#ifndef _GNU_SOURCE
 #define _GNU_SOURCE /* Stupid GNU :-P */
-#endif
 
 #define PACKAGE "BitlBee"
-#define BITLBEE_VERSION "3.6"
+#define BITLBEE_VERSION "0.99"
 #define VERSION BITLBEE_VERSION
-#define BITLBEE_VER(a, b, c) (((a) << 16) + ((b) << 8) + (c))
-#define BITLBEE_VERSION_CODE BITLBEE_VER(3, 6, 0)
-#define BITLBEE_ABI_VERSION_CODE 1
 
-#define MAX_STRING 511
+#define MAX_STRING 128
 
-#if HAVE_CONFIG_H
-#include <config.h>
-#endif
+#include "config.h"
 
 #include <fcntl.h>
@@ -57,6 +46,9 @@
 #include <stdio.h>
 #include <ctype.h>
+#ifndef _WIN32
+#include <syslog.h>
 #include <errno.h>
-#include <syslog.h>
+#endif
+
 #include <glib.h>
 #include <gmodule.h>
@@ -64,59 +56,30 @@
 /* The following functions should not be used if we want to maintain Windows compatibility... */
 #undef free
-#define free            __PLEASE_USE_THE_GLIB_MEMORY_ALLOCATION_SYSTEM__
+#define free		__PLEASE_USE_THE_GLIB_MEMORY_ALLOCATION_SYSTEM_INSTEAD__
 #undef malloc
-#define malloc          __PLEASE_USE_THE_GLIB_MEMORY_ALLOCATION_SYSTEM__
+#define malloc		__PLEASE_USE_THE_GLIB_MEMORY_ALLOCATION_SYSTEM_INSTEAD__
 #undef calloc
-#define calloc          __PLEASE_USE_THE_GLIB_MEMORY_ALLOCATION_SYSTEM__
+#define calloc		__PLEASE_USE_THE_GLIB_MEMORY_ALLOCATION_SYSTEM_INSTEAD__
 #undef realloc
-#define realloc         __PLEASE_USE_THE_GLIB_MEMORY_ALLOCATION_SYSTEM__
+#define realloc		__PLEASE_USE_THE_GLIB_MEMORY_ALLOCATION_SYSTEM_INSTEAD__
 #undef strdup
-#define strdup          __PLEASE_USE_THE_GLIB_STRDUP_FUNCTIONS_SYSTEM__
+#define strdup		__PLEASE_USE_THE_GLIB_STRDUP_FUNCTIONS_SYSTEM_INSTEAD__
 #undef strndup
-#define strndup         __PLEASE_USE_THE_GLIB_STRDUP_FUNCTIONS_SYSTEM__
+#define strndup		__PLEASE_USE_THE_GLIB_STRDUP_FUNCTIONS_SYSTEM_INSTEAD__
 #undef snprintf
-#define snprintf        __PLEASE_USE_G_SNPRINTF__
+#define snprintf	__PLEASE_USE_G_SNPRINTF_INSTEAD__
 #undef strcasecmp
-#define strcasecmp      __PLEASE_USE_G_STRCASECMP__
+#define strcasecmp	__PLEASE_USE_G_STRCASECMP_INSTEAD__
 #undef strncasecmp
-#define strncasecmp     __PLEASE_USE_G_STRNCASECMP__
+#define strncasecmp	__PLEASE_USE_G_STRNCASECMP_INSTEAD__
 
-/* And the following functions shouldn't be used anymore to keep compatibility
-   with other event handling libs than GLib. */
-#undef g_timeout_add
-#define g_timeout_add           __PLEASE_USE_B_TIMEOUT_ADD__
-#undef g_timeout_add_full
-#define g_timeout_add_full      __PLEASE_USE_B_TIMEOUT_ADD__
-#undef g_io_add_watch
-#define g_io_add_watch          __PLEASE_USE_B_INPUT_ADD__
-#undef g_io_add_watch_full
-#define g_io_add_watch_full     __PLEASE_USE_B_INPUT_ADD__
-#undef g_source_remove
-#define g_source_remove         __PLEASE_USE_B_EVENT_REMOVE__
-#undef g_main_run
-#define g_main_run              __PLEASE_USE_B_MAIN_RUN__
-#undef g_main_quit
-#define g_main_quit             __PLEASE_USE_B_MAIN_QUIT__
-
-/* And now, because GLib folks think everyone loves typing ridiculously long
-   function names ... no I don't or I'd write BitlBee in Java, ffs. */
-#define g_strcasecmp g_ascii_strcasecmp
-#define g_strncasecmp g_ascii_strncasecmp
-
-/* g_memdup() deprecated as of glib 2.68.0 */
-#ifndef GLIB_VERSION_2_68
-#define g_memdup2 g_memdup
+#ifndef F_OK
+#define F_OK 0
 #endif
 
-#ifndef G_GNUC_MALLOC
-/* Doesn't exist in GLib <=2.4 while everything else in BitlBee should
-   work with it, so let's fake this one. */
-#define G_GNUC_MALLOC
-#endif
-
-#define _(x) x
+#define _( x ) x
 
 #define ROOT_NICK "root"
-#define ROOT_CHAN "&bitlbee"
+#define ROOT_CHAN "#bitlbee"
 #define ROOT_FN "User manager"
 
@@ -124,6 +87,6 @@
 
 #define DEFAULT_AWAY "Away from computer"
-#define CONTROL_TOPIC "Welcome to the control channel. Type \2help\2 for help information."
-#define IRCD_INFO PACKAGE " <https://www.bitlbee.org/>"
+#define CONTROL_TOPIC "Welcome to the control channel. Type help for help information."
+#define IRCD_INFO "BitlBee <http://www.bitlbee.org/>"
 
 #define MAX_NICK_LENGTH 24
@@ -132,62 +95,44 @@
 #define CONF_FILE_DEF ETCDIR "bitlbee.conf"
 
-/* Hack to give a little bit more password security on IRC: If an account has
-   this password set, use /OPER to change it. */
-#define PASSWORD_PENDING "\r\rchangeme\r\r"
+extern char *CONF_FILE;
 
-#include "bee.h"
 #include "irc.h"
-#include "storage.h"
-#include "auth.h"
 #include "set.h"
-#include "nogaim.h"
+#include "protocols/nogaim.h"
 #include "commands.h"
 #include "account.h"
-#include "nick.h"
 #include "conf.h"
 #include "log.h"
 #include "ini.h"
+#include "help.h"
 #include "query.h"
+#include "debug.h"
 #include "sock.h"
-#include "misc.h"
-#include "proxy.h"
 
-typedef struct global {
-	/* In forked mode, child processes store the fd of the IPC socket here. */
+typedef struct global_t {
 	int listen_socket;
-	gint listen_watch_source_id;
-	struct help *help;
-	char *conf_file;
+	help_t *help;
 	conf_t *conf;
-	GList *storage; /* The first backend in the list will be used for saving */
-	GList *auth;    /* Authentication backends */
 	char *helpfile;
-	int restart;
+	GMainLoop *loop;
 } global_t;
 
-void sighandler_shutdown_setup(void);
+int bitlbee_daemon_init( void );
+int bitlbee_inetd_init( void );
 
-int bitlbee_daemon_init(void);
-int bitlbee_inetd_init(void);
+gboolean bitlbee_io_current_client_read( GIOChannel *source, GIOCondition condition, gpointer data );
+gboolean bitlbee_io_current_client_write( GIOChannel *source, GIOCondition condition, gpointer data );
 
-gboolean bitlbee_io_current_client_read(gpointer data, gint source, b_input_condition cond);
-gboolean bitlbee_io_current_client_write(gpointer data, gint source, b_input_condition cond);
-
-void root_command_string(irc_t *irc, char *command);
-void root_command(irc_t *irc, char *command[]);
-gboolean root_command_add(const char *command, int params, void (*func)(irc_t *, char **args), int flags);
-gboolean cmd_identify_finish(gpointer data, gint fd, b_input_condition cond);
-void cmd_chat_list_finish(struct im_connection *ic);
-gboolean bitlbee_shutdown(gpointer data, gint fd, b_input_condition cond);
-
-char *set_eval_root_nick(set_t *set, char *new_nick);
-char *set_eval_control_channel(set_t *set, char *new_name);
+int root_command_string( irc_t *irc, user_t *u, char *command, int flags );
+int root_command( irc_t *irc, char *command[] );
+int bitlbee_load( irc_t *irc, char *password );
+int bitlbee_save( irc_t *irc );
+void bitlbee_shutdown( gpointer data );
+double gettime( void );
+G_MODULE_EXPORT void http_encode( char *s );
+G_MODULE_EXPORT void http_decode( char *s );
+G_MODULE_EXPORT char *strip_newlines(char *source);
 
 extern global_t global;
 
-#ifdef __cplusplus
-}
 #endif
-
-#endif
-
Index: commands.c
===================================================================
--- commands.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ commands.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,804 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* User manager (root) commands                                         */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#define BITLBEE_CORE
+#include "commands.h"
+#include "crypting.h"
+#include "bitlbee.h"
+#include "help.h"
+
+#include <string.h>
+
+command_t commands[] = {
+	{ "help",           0, cmd_help }, 
+	{ "identify",       1, cmd_identify },
+	{ "register",       1, cmd_register },
+	{ "drop",           1, cmd_drop },
+	{ "account",        1, cmd_account },
+	{ "add",            2, cmd_add },
+	{ "info",           1, cmd_info },
+	{ "rename",         2, cmd_rename },
+	{ "remove",         1, cmd_remove },
+	{ "block",          1, cmd_block },
+	{ "allow",          1, cmd_allow },
+	{ "save",           0, cmd_save },
+	{ "set",            0, cmd_set },
+	{ "yes",            0, cmd_yesno },
+	{ "no",             0, cmd_yesno },
+	{ "blist",          0, cmd_blist },
+	{ "nick",           1, cmd_nick },
+	{ "import_buddies", 1, cmd_import_buddies },
+	{ "qlist",          0, cmd_qlist },
+	{ "dump",	    0, cmd_dump },
+	{ NULL }
+};
+
+int cmd_help( irc_t *irc, char **cmd )
+{
+	char param[80];
+	int i;
+	char *s;
+	
+	memset( param, 0, sizeof(param) );
+	for ( i = 1; (cmd[i] != NULL && ( strlen(param) < (sizeof(param)-1) ) ); i++ ) {
+		if ( i != 1 )	// prepend space except for the first parameter
+			strcat(param, " ");
+		strncat( param, cmd[i], sizeof(param) - strlen(param) - 1 );
+	}
+
+	s = help_get( &(global.help), param );
+	if( !s ) s = help_get( &(global.help), "" );
+	
+	if( s )
+	{
+		irc_usermsg( irc, "%s", s );
+		g_free( s );
+		return( 1 );
+	}
+	else
+	{
+		irc_usermsg( irc, "Error opening helpfile." );
+		return( 0 );
+	}
+}
+
+int cmd_identify( irc_t *irc, char **cmd )
+{
+	int checkie = bitlbee_load( irc, cmd[1] );
+	
+	if( checkie == -1 )
+	{
+		irc_usermsg( irc, "Incorrect password" );
+	}
+	else if( checkie == 0 )
+	{
+		irc_usermsg( irc, "The nick is (probably) not registered" );
+	}
+	else if( checkie == 1 )
+	{
+		irc_usermsg( irc, "Password accepted" );
+	}
+	else
+	{
+		irc_usermsg( irc, "Something very weird happened" );
+	}
+	
+	return( 0 );
+}
+
+int cmd_register( irc_t *irc, char **cmd )
+{
+	int checkie;
+	char path[512];
+	
+	if( global.conf->authmode == AUTHMODE_REGISTERED )
+	{
+		irc_usermsg( irc, "This server does not allow registering new accounts" );
+		return( 0 );
+	}
+	
+	g_snprintf( path, 511, "%s%s%s", global.conf->configdir, irc->nick, ".accounts" );
+	checkie = access( path, F_OK );
+	
+	g_snprintf( path, 511, "%s%s%s", global.conf->configdir, irc->nick, ".nicks" );
+	checkie += access( path, F_OK );
+	
+	if( checkie == -2 )
+	{
+		setpassnc( irc, cmd[1] );
+		root_command_string( irc, user_find( irc, irc->mynick ), "save", 0 );
+		irc->status = USTATUS_IDENTIFIED;
+	}
+	else
+	{
+		irc_usermsg( irc, "Nick is already registered" );
+	}
+	
+	return( 0 );
+}
+
+int cmd_drop( irc_t *irc, char **cmd )
+{
+	char s[512];
+	FILE *fp;
+	
+	g_snprintf( s, 511, "%s%s%s", global.conf->configdir, irc->nick, ".accounts" );
+	fp = fopen( s, "r" );
+	if( !fp )
+	{
+		irc_usermsg( irc, "That account does not exist" );
+		return( 0 );
+	}
+	
+	fscanf( fp, "%32[^\n]s", s );
+	fclose( fp );
+	if( setpass( irc, cmd[1], s ) < 0 )
+	{
+		irc_usermsg( irc, "Incorrect password" );
+		return( 0 );
+	}
+	
+	g_snprintf( s, 511, "%s%s%s", global.conf->configdir, irc->nick, ".accounts" );
+	unlink( s );
+	
+	g_snprintf( s, 511, "%s%s%s", global.conf->configdir, irc->nick, ".nicks" );
+	unlink( s );
+	
+	setpassnc( irc, NULL );
+	irc_usermsg( irc, "Files belonging to account `%s' removed", irc->nick );
+	
+	return( 0 );
+}
+
+int cmd_account( irc_t *irc, char **cmd )
+{
+	account_t *a;
+	
+	if( global.conf->authmode == AUTHMODE_REGISTERED && irc->status < USTATUS_IDENTIFIED )
+	{
+		irc_usermsg( irc, "This server only accepts registered users" );
+		return( 0 );
+	}
+	
+	if( g_strcasecmp( cmd[1], "add" ) == 0 )
+	{
+		int prot;
+		
+		if( cmd[2] == NULL || cmd[3] == NULL || cmd[4] == NULL )
+		{
+			irc_usermsg( irc, "Not enough parameters" );
+			return( 0 );
+		}
+		
+		for( prot = 0; prot < PROTO_MAX; prot ++ )
+			if( proto_name[prot] && *proto_name[prot] && g_strcasecmp( proto_name[prot], cmd[2] ) == 0 )
+				break;
+		
+		if( ( prot == PROTO_MAX ) || ( proto_prpl[prot] == NULL ) )
+		{
+			irc_usermsg( irc, "Unknown protocol" );
+			return( 0 );
+		}
+
+		if( prot == PROTO_OSCAR && cmd[5] == NULL )
+		{
+			irc_usermsg( irc, "Not enough parameters" );
+			return( 0 );
+		}
+		
+		a = account_add( irc, prot, cmd[3], cmd[4] );
+		
+		if( cmd[5] )
+			a->server = g_strdup( cmd[5] );
+		
+		irc_usermsg( irc, "Account successfully added" );
+	}
+	else if( g_strcasecmp( cmd[1], "del" ) == 0 )
+	{
+		if( !cmd[2] )
+		{
+			irc_usermsg( irc, "Not enough parameters given (need %d)", 2 );
+		}
+		else if( !( a = account_get( irc, cmd[2] ) ) )
+		{
+			irc_usermsg( irc, "Invalid account" );
+		}
+		else if( a->gc )
+		{
+			irc_usermsg( irc, "Account is still logged in, can't delete" );
+		}
+		else
+		{
+			account_del( irc, a );
+			irc_usermsg( irc, "Account deleted" );
+		}
+	}
+	else if( g_strcasecmp( cmd[1], "list" ) == 0 )
+	{
+		int i = 0;
+		
+		for( a = irc->accounts; a; a = a->next )
+		{
+			char *con;
+			
+			if( a->gc && ( a->gc->flags & OPT_LOGGED_IN ) )
+				con = " (connected)";
+			else if( a->gc )
+				con = " (connecting)";
+			else if( a->reconnect )
+				con = " (awaiting reconnect)";
+			else
+				con = "";
+			
+			if( a->protocol == PROTO_OSCAR || a->protocol == PROTO_ICQ || a->protocol == PROTO_TOC )
+				irc_usermsg( irc, "%2d. OSCAR, %s on %s%s", i, a->user, a->server, con );
+			else
+				irc_usermsg( irc, "%2d. %s, %s%s", i, proto_name[a->protocol], a->user, con );
+			
+			i ++;
+		}
+		irc_usermsg( irc, "End of account list" );
+	}
+	else if( g_strcasecmp( cmd[1], "on" ) == 0 )
+	{
+		if( cmd[2] )
+		{
+			if( ( a = account_get( irc, cmd[2] ) ) )
+			{
+				if( a->gc )
+				{
+					irc_usermsg( irc, "Account already online" );
+					return( 0 );
+				}
+				else
+				{
+					account_on( irc, a );
+				}
+			}
+			else
+			{
+				irc_usermsg( irc, "Invalid account" );
+				return( 0 );
+			}
+		}
+		else
+		{
+			if ( irc->accounts ) {
+				irc_usermsg( irc, "Trying to get all accounts connected..." );
+			
+				for( a = irc->accounts; a; a = a->next )
+					if( !a->gc )
+						account_on( irc, a );
+			} 
+			else
+			{
+				irc_usermsg( irc, "No accounts known. Use 'account add' to add one." );
+			}
+		}
+	}
+	else if( g_strcasecmp( cmd[1], "off" ) == 0 )
+	{
+		if( !cmd[2] )
+		{
+			irc_usermsg( irc, "Deactivating all active (re)connections..." );
+			
+			for( a = irc->accounts; a; a = a->next )
+			{
+				if( a->gc )
+					account_off( irc, a );
+				else if( a->reconnect )
+					cancel_auto_reconnect( a );
+			}
+		}
+		else if( ( a = account_get( irc, cmd[2] ) ) )
+		{
+			if( a->gc )
+			{
+				account_off( irc, a );
+			}
+			else if( a->reconnect )
+			{
+				cancel_auto_reconnect( a );
+				irc_usermsg( irc, "Reconnect cancelled" );
+			}
+			else
+			{
+				irc_usermsg( irc, "Account already offline" );
+				return( 0 );
+			}
+		}
+		else
+		{
+			irc_usermsg( irc, "Invalid account" );
+			return( 0 );
+		}
+	}
+	else
+	{
+		irc_usermsg( irc, "Unknown command: account %s. Please use help commands to get a list of available commands.", cmd[1] );
+	}
+	
+	return( 1 );
+}
+
+int cmd_add( irc_t *irc, char **cmd )
+{
+	account_t *a;
+	
+	if( !( a = account_get( irc, cmd[1] ) ) )
+	{
+		irc_usermsg( irc, "Invalid account" );
+		return( 1 );
+	}
+	else if( !( a->gc && ( a->gc->flags & OPT_LOGGED_IN ) ) )
+	{
+		irc_usermsg( irc, "That account is not on-line" );
+		return( 1 );
+	}
+	
+	if( cmd[3] )
+	{
+		if( !nick_ok( cmd[3] ) )
+		{
+			irc_usermsg( irc, "The requested nick `%s' is invalid", cmd[3] );
+			return( 0 );
+		}
+		else if( user_find( irc, cmd[3] ) )
+		{
+			irc_usermsg( irc, "The requested nick `%s' already exists", cmd[3] );
+			return( 0 );
+		}
+		else
+		{
+			nick_set( irc, cmd[2], a->gc->protocol, cmd[3] );
+		}
+	}
+	a->gc->prpl->add_buddy( a->gc, cmd[2] );
+	add_buddy( a->gc, NULL, cmd[2], cmd[2] );
+	
+	irc_usermsg( irc, "User `%s' added to your contact list as `%s'", cmd[2], user_findhandle( a->gc, cmd[2] )->nick );
+	
+	return( 0 );
+}
+
+int cmd_info( irc_t *irc, char **cmd )
+{
+	struct gaim_connection *gc;
+	account_t *a;
+	
+	if( !cmd[2] )
+	{
+		user_t *u = user_find( irc, cmd[1] );
+		if( !u || !u->gc )
+		{
+			irc_usermsg( irc, "Nick `%s' does not exist", cmd[1] );
+			return( 1 );
+		}
+		gc = u->gc;
+		cmd[2] = u->handle;
+	}
+	else if( !( a = account_get( irc, cmd[1] ) ) )
+	{
+		irc_usermsg( irc, "Invalid account" );
+		return( 1 );
+	}
+	else if( !( ( gc = a->gc ) && ( a->gc->flags & OPT_LOGGED_IN ) ) )
+	{
+		irc_usermsg( irc, "That account is not on-line" );
+		return( 1 );
+	}
+	
+	if( !gc->prpl->get_info )
+	{
+		irc_usermsg( irc, "Command `%s' not supported by this protocol", cmd[0] );
+		return( 1 );
+	}
+	gc->prpl->get_info( gc, cmd[2] );
+	
+	return( 0 );
+}
+
+int cmd_rename( irc_t *irc, char **cmd )
+{
+	user_t *u;
+	
+	if( g_strcasecmp( cmd[1], irc->nick ) == 0 )
+	{
+		irc_usermsg( irc, "Nick `%s' can't be changed", cmd[1] );
+		return( 1 );
+	}
+	if( user_find( irc, cmd[2] ) && ( nick_cmp( cmd[1], cmd[2] ) != 0 ) )
+	{
+		irc_usermsg( irc, "Nick `%s' already exists", cmd[2] );
+		return( 1 );
+	}
+	if( !nick_ok( cmd[2] ) )
+	{
+		irc_usermsg( irc, "Nick `%s' is invalid", cmd[2] );
+		return( 1 );
+	}
+	if( !( u = user_find( irc, cmd[1] ) ) )
+	{
+		irc_usermsg( irc, "Nick `%s' does not exist", cmd[1] );
+		return( 1 );
+	}
+	user_rename( irc, cmd[1], cmd[2] );
+	irc_write( irc, ":%s!%s@%s NICK %s", cmd[1], u->user, u->host, cmd[2] );
+	if( g_strcasecmp( cmd[1], irc->mynick ) == 0 )
+	{
+		g_free( irc->mynick );
+		irc->mynick = g_strdup( cmd[2] );
+	}
+	else if( u->send_handler == buddy_send_handler )
+	{
+		nick_set( irc, u->handle, u->gc->protocol, cmd[2] );
+	}
+	
+	irc_usermsg( irc, "Nick successfully changed" );
+	
+	return( 0 );
+}
+
+int cmd_remove( irc_t *irc, char **cmd )
+{
+	user_t *u;
+	char *s;
+	
+	if( !( u = user_find( irc, cmd[1] ) ) || !u->gc )
+	{
+		irc_usermsg( irc, "Buddy `%s' not found", cmd[1] );
+		return( 1 );
+	}
+	s = g_strdup( u->handle );
+	
+	u->gc->prpl->remove_buddy( u->gc, u->handle, NULL );
+	user_del( irc, cmd[1] );
+	nick_del( irc, cmd[1] );
+	
+	irc_usermsg( irc, "Buddy `%s' (nick %s) removed from contact list", s, cmd[1] );
+	g_free( s );
+	
+	return( 0 );
+}
+
+int cmd_block( irc_t *irc, char **cmd )
+{
+	struct gaim_connection *gc;
+	account_t *a;
+	
+	if( !cmd[2] )
+	{
+		user_t *u = user_find( irc, cmd[1] );
+		if( !u || !u->gc )
+		{
+			irc_usermsg( irc, "Nick `%s' does not exist", cmd[1] );
+			return( 1 );
+		}
+		gc = u->gc;
+		cmd[2] = u->handle;
+	}
+	else if( !( a = account_get( irc, cmd[1] ) ) )
+	{
+		irc_usermsg( irc, "Invalid account" );
+		return( 1 );
+	}
+	else if( !( ( gc = a->gc ) && ( a->gc->flags & OPT_LOGGED_IN ) ) )
+	{
+		irc_usermsg( irc, "That account is not on-line" );
+		return( 1 );
+	}
+	
+	if( !gc->prpl->add_deny || !gc->prpl->rem_permit )
+	{
+		irc_usermsg( irc, "Command `%s' not supported by this protocol", cmd[0] );
+	}
+	else
+	{
+		gc->prpl->rem_permit( gc, cmd[2] );
+		gc->prpl->add_deny( gc, cmd[2] );
+		irc_usermsg( irc, "Buddy `%s' moved from your permit- to your deny-list", cmd[2] );
+	}
+	
+	return( 0 );
+}
+
+int cmd_allow( irc_t *irc, char **cmd )
+{
+	struct gaim_connection *gc;
+	account_t *a;
+	
+	if( !cmd[2] )
+	{
+		user_t *u = user_find( irc, cmd[1] );
+		if( !u || !u->gc )
+		{
+			irc_usermsg( irc, "Nick `%s' does not exist", cmd[1] );
+			return( 1 );
+		}
+		gc = u->gc;
+		cmd[2] = u->handle;
+	}
+	else if( !( a = account_get( irc, cmd[1] ) ) )
+	{
+		irc_usermsg( irc, "Invalid account" );
+		return( 1 );
+	}
+	else if( !( ( gc = a->gc ) && ( a->gc->flags & OPT_LOGGED_IN ) ) )
+	{
+		irc_usermsg( irc, "That account is not on-line" );
+		return( 1 );
+	}
+	
+	if( !gc->prpl->rem_deny || !gc->prpl->add_permit )
+	{
+		irc_usermsg( irc, "Command `%s' not supported by this protocol", cmd[0] );
+	}
+	else
+	{
+		gc->prpl->rem_deny( gc, cmd[2] );
+		gc->prpl->add_permit( gc, cmd[2] );
+		
+		irc_usermsg( irc, "Buddy `%s' moved from your deny- to your permit-list", cmd[2] );
+	}
+	
+	return( 0 );
+}
+
+int cmd_yesno( irc_t *irc, char **cmd )
+{
+	query_t *q = NULL;
+	int numq = 0;
+	
+	if( irc->queries == NULL )
+	{
+		irc_usermsg( irc, "Did I ask you something?" );
+		return( 0 );
+	}
+	
+	/* If there's an argument, the user seems to want to answer another question than the
+	   first/last (depending on the query_order setting) one. */
+	if( cmd[1] )
+	{
+		if( sscanf( cmd[1], "%d", &numq ) != 1 )
+		{
+			irc_usermsg( irc, "Invalid query number" );
+			return( 0 );
+		}
+		
+		for( q = irc->queries; q; q = q->next, numq -- )
+			if( numq == 0 )
+				break;
+		
+		if( !q )
+		{
+			irc_usermsg( irc, "Uhm, I never asked you something like that..." );
+			return( 0 );
+		}
+	}
+	
+	if( g_strcasecmp( cmd[0], "yes" ) == 0 )
+		query_answer( irc, q, 1 );
+	else if( g_strcasecmp( cmd[0], "no" ) == 0 )
+		query_answer( irc, q, 0 );
+	
+	return( 1 );
+}
+
+int cmd_set( irc_t *irc, char **cmd )
+{
+	if( cmd[1] && cmd[2] )
+	{
+		set_setstr( irc, cmd[1], cmd[2] );
+	}
+	if( cmd[1] ) /* else 'forgotten' on purpose.. Must show new value after changing */
+	{
+		char *s = set_getstr( irc, cmd[1] );
+		if( s )
+			irc_usermsg( irc, "%s = `%s'", cmd[1], s );
+	}
+	else
+	{
+		set_t *s = irc->set;
+		while( s )
+		{
+			if( s->value || s->def )
+				irc_usermsg( irc, "%s = `%s'", s->key, s->value?s->value:s->def );
+			s = s->next;
+		}
+	}
+	
+	return( 0 );
+}
+
+int cmd_save( irc_t *irc, char **cmd )
+{
+	if( bitlbee_save( irc ) )
+		irc_usermsg( irc, "Configuration saved" );
+	else
+		irc_usermsg( irc, "Configuration could not be saved!" );
+	
+	return( 0 );
+}
+
+int cmd_blist( irc_t *irc, char **cmd )
+{
+	int online = 0, away = 0, offline = 0;
+	user_t *u;
+	char s[64];
+	int n_online = 0, n_away = 0, n_offline = 0;
+	
+	if( cmd[1] && g_strcasecmp( cmd[1], "all" ) == 0 )
+		online = offline = away = 1;
+	else if( cmd[1] && g_strcasecmp( cmd[1], "offline" ) == 0 )
+		offline = 1;
+	else if( cmd[1] && g_strcasecmp( cmd[1], "away" ) == 0 )
+		away = 1;
+	else if( cmd[1] && g_strcasecmp( cmd[1], "online" ) == 0 )
+		online = 1;
+	else
+		online =  away = 1;
+	
+	irc_usermsg( irc, "%-16.16s  %-40.40s  %s", "Nick", "User/Host/Network", "Status" );
+	
+	if( online == 1 ) for( u = irc->users; u; u = u->next ) if( u->gc && u->online && !u->away )
+	{
+		g_snprintf( s, 63, "%s@%s (%s)", u->user, u->host, proto_name[u->gc->user->protocol] );
+		irc_usermsg( irc, "%-16.16s  %-40.40s  %s", u->nick, s, "Online" );
+		n_online ++;
+	}
+
+	if( away == 1 ) for( u = irc->users; u; u = u->next ) if( u->gc && u->online && u->away )
+	{
+		g_snprintf( s, 63, "%s@%s (%s)", u->user, u->host, proto_name[u->gc->user->protocol] );
+		irc_usermsg( irc, "%-16.16s  %-40.40s  %s", u->nick, s, u->away );
+		n_away ++;
+	}
+	
+	if( offline == 1 ) for( u = irc->users; u; u = u->next ) if( u->gc && !u->online )
+	{
+		g_snprintf( s, 63, "%s@%s (%s)", u->user, u->host, proto_name[u->gc->user->protocol] );
+		irc_usermsg( irc, "%-16.16s  %-40.40s  %s", u->nick, s, "Offline" );
+		n_offline ++;
+	}
+	
+	irc_usermsg( irc, "%d buddies (%d available, %d away, %d offline)", n_online + n_away + n_offline, n_online, n_away, n_offline );
+	
+	return( 0 );
+}
+
+int cmd_nick( irc_t *irc, char **cmd ) 
+{
+	account_t *a;
+
+	if( !cmd[1] || !( a = account_get( irc, cmd[1] ) ) )
+	{
+		irc_usermsg( irc, "Invalid account");
+	}
+	else if( !( a->gc && ( a->gc->flags & OPT_LOGGED_IN ) ) )
+	{
+		irc_usermsg( irc, "That account is not on-line" );
+	}
+	else if ( !cmd[2] ) 
+	{
+		irc_usermsg( irc, "Your name is `%s'" , a->gc->displayname ? a->gc->displayname : "NULL" );
+	}
+	else if ( !a->gc->prpl->set_info ) 
+	{
+		irc_usermsg( irc, "Command `%s' not supported by this protocol", cmd[0] );
+	}
+	else
+	{
+		char utf8[1024];
+		
+		irc_usermsg( irc, "Setting your name to `%s'", cmd[2] );
+		
+		if( g_strncasecmp( set_getstr( irc, "charset" ), "none", 4 ) != 0 &&
+		    do_iconv( set_getstr( irc, "charset" ), "UTF-8", cmd[2], utf8, 0, 1024 ) != -1 )
+			a->gc->prpl->set_info( a->gc, utf8 );
+		else
+			a->gc->prpl->set_info( a->gc, cmd[2] );
+	}
+	
+	return( 1 );
+}
+
+int cmd_qlist( irc_t *irc, char **cmd )
+{
+	query_t *q = irc->queries;
+	int num;
+	
+	if( !q )
+	{
+		irc_usermsg( irc, "There are no pending questions." );
+		return( 0 );
+	}
+	
+	irc_usermsg( irc, "Pending queries:" );
+	
+	for( num = 0; q; q = q->next, num ++ )
+		irc_usermsg( irc, "%d, %s", num, q->question );
+	
+	return( 0 );
+}
+
+int cmd_import_buddies( irc_t *irc, char **cmd )
+{
+	struct gaim_connection *gc;
+	account_t *a;
+	nick_t *n;
+	
+	if( !( a = account_get( irc, cmd[1] ) ) )
+	{
+		irc_usermsg( irc, "Invalid account" );
+		return( 0 );
+	}
+	else if( !( ( gc = a->gc ) && ( a->gc->flags & OPT_LOGGED_IN ) ) )
+	{
+		irc_usermsg( irc, "That account is not on-line" );
+		return( 0 );
+	}
+	
+	if( cmd[2] )
+	{
+		if( g_strcasecmp( cmd[2], "clear" ) == 0 )
+		{
+			user_t *u;
+			
+			for( u = irc->users; u; u = u->next )
+				if( u->gc == gc )
+				{
+					u->gc->prpl->remove_buddy( u->gc, u->handle, NULL );
+					user_del( irc, u->nick );
+				}
+			
+			irc_usermsg( irc, "Old buddy list cleared." );
+		}
+		else
+		{
+			irc_usermsg( irc, "Invalid argument: %s", cmd[2] );
+			return( 0 );
+		}
+	}
+	
+	for( n = gc->irc->nicks; n; n = n->next )
+	{
+		if( n->proto == gc->protocol && !user_findhandle( gc, n->handle ) )
+		{
+	                gc->prpl->add_buddy( gc, n->handle );
+	                add_buddy( gc, NULL, n->handle, NULL );
+		}
+	}
+	
+	irc_usermsg( irc, "Sent all add requests. Please wait for a while, the server needs some time to handle all the adds." );
+	
+	return( 0 );
+}
+
+int cmd_dump( irc_t *irc, char **cmd ) {
+	write_io_activity();
+	irc_usermsg(irc, "Wrote GIO activity log to disk.");	
+	
+	return( 0 );
+}
Index: commands.h
===================================================================
--- commands.h	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ commands.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,3 +1,3 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
@@ -20,6 +20,6 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
@@ -29,19 +29,36 @@
 #include "bitlbee.h"
 
-typedef struct command {
+/* Hmm... Linked list? Plleeeeaaase?? ;-) */
+
+typedef struct command_t
+{
 	char *command;
 	int required_parameters;
-	void (*execute)(irc_t *, char **args);
-	int flags;
+	int (*execute)(irc_t *, char **args);
 } command_t;
 
-extern command_t root_commands[];
+int cmd_account( irc_t *irc, char **cmd );
+int cmd_help( irc_t *irc, char **args);
+int cmd_info( irc_t *irc, char **args);
+int cmd_add( irc_t *irc, char **args) ;
+int cmd_rename( irc_t *irc, char **args );
+int cmd_remove( irc_t *irc, char **args );
+int cmd_block( irc_t *irc, char **args );
+int cmd_allow( irc_t *irc, char **args );
+int cmd_save( irc_t *irc, char **args );
+int cmd_set( irc_t *irc, char **args );
+int cmd_yesno( irc_t *irc, char **args );
+int cmd_identify( irc_t *irc, char **args );
+int cmd_register( irc_t *irc, char **args );
+int cmd_drop( irc_t *irc, char **args );
+int cmd_blist( irc_t *irc, char **cmd );
+int cmd_nick( irc_t *irc, char **cmd );
+int cmd_qlist( irc_t *irc, char **cmd );
+int cmd_import_buddies( irc_t *irc, char **cmd );
+int cmd_dump( irc_t *irc, char **cmd );
 
-#define IRC_CMD_PRE_LOGIN       1
-#define IRC_CMD_LOGGED_IN       2
-#define IRC_CMD_OPER_ONLY       4
-#define IRC_CMD_TO_MASTER       8
 
-#define IPC_CMD_TO_CHILDREN     1
+
+extern command_t commands[];
 
 #endif
